/*
 * (c) copyright 2019-2020 Universidade de Vigo. All rights reserved.
 * formella@uvigo.es, http://formella.webs.uvigo.es
 */

// Note that the exceptions in this file are just placeholders.
// We don't expect any exception to happen.
// If one happens, well we have to come back here...

class Mul implements Runnable {
  private int id; // thread identity
  private Int p;  // reference to shared first factor
  private Int q;  // reference to shared second factor
  private Int r;  // reference to shared result

  Mul(int id, Int p, Int q, Int r) {
    this.id=id;
    this.p=p;
    this.q=q;
    this.r=r;
  }

  public void run() {
    try {
      System.out.println("starting worker... "+id);
      Int minusOne=new Int(-1);
      while(q.Get()>0) {
        r.Add(p);
        q.Add(minusOne);
      }
    }
    catch(Exception E) { System.out.println("??? "+id); }
    finally { System.out.println("exiting... "+id); }
  }
}

class Multi {
  static Int p,q,r; // our shared variables for r=p*q

  public static void main(String[] args) {
    try {
      if(args.length!=3) {
        System.out.println("please 3 arg's: p q n");
        System.exit(1);
      }
 
      p=new Int(Integer.parseInt(args[0]));
      q=new Int(Integer.parseInt(args[1]));
      r=new Int(0);

      final int n=Integer.parseInt(args[2]);
      final Thread[] threads=new Thread[n];

      System.out.println(
        p.Get()+"*"+q.Get()+" with "+n+" threads"
      );

      for(int i=0; i<threads.length; ++i) {
        threads[i]=new Thread(new Mul(i,p,q,r));
      }

      for(int i=0; i<threads.length; ++i) {
        threads[i].start();
      }

      for(int i=0; i<threads.length; ++i) {
        threads[i].join();
      }

      System.out.println(
        args[0]+"*"+args[1]+"="+r.Get()+" ??"
      );
    }
    catch(Exception E) {
      System.out.println("catched an exception...");
      System.exit(1);
    }
    finally {
      System.out.println("exiting...");
    }
  }
}

