/*
 * (c) copyright 2019 Universidade de Vigo. All rights reserved.
 * formella@uvigo.es, http://formella.webs.uvigo.es
 */

import java.util.concurrent.locks.*;

  // Implementation of semaphore according to pseudo code.
class MySemaphore {
  private int cnt;
  private ReentrantLock mutex;
  private ReentrantLock delay;
  MySemaphore(int n) {
    cnt=n;
    mutex=new ReentrantLock();
    delay=new ReentrantLock();
  }
  public void acquire() {
    delay.lock();
    mutex.lock();
    --cnt;
    if(cnt>0) delay.unlock();
    mutex.unlock();
  }
  public void release() {
    mutex.lock();
    ++cnt;
    if(cnt==1) delay.unlock();
    mutex.unlock();
  }
}
